@echo ***************************************************************
@echo *** Aggressive Games Search Tool V3.9 by Stefan Pohl (SPCC) ***
@echo ***        Turbo special-version for sacrifices, only       ***
@echo ***               (C) 2022, www.sp-cc.de                    ***
@echo ***************************************************************
@echo ***     This tool uses pgn-extract (C) David J. Barnes      ***
@echo ***************************************************************
@echo ***************************************************************
@echo Gib den Dateinamen der zu untersuchenden pgn-Datei ein (ohne die Endung .pgn !!!):
@echo off
set /p filename=
set gamebase=%filename%.pgn
@echo ***************************************************************
@echo Gebe 1 ein (oder nur Return), um nach allen Opfern (mindestens ein Bauer) zu suchen.
@echo Gebe 2 ein, um nach Opfern mit mindestens 2 Bauern zu suchen.
@echo Gebe 3 ein, um nach Opfern von Figuren (nicht ausschliesslich Bauern) im Wert von 2 Bauern zu suchen.
set /p input=
set /A whatwork=input
if %whatwork% LSS 1 set /A whatwork=1
if %whatwork% GTR 3 set /A whatwork=3
@echo ***************************************************************
@echo Gib die maximale Zuglaenge der Gewinnpartien ein, die das Tool untersuchen soll. Fuer Menschpartien
@echo sind mindestens 80 Zuege empfohlen, fuer Enginepartien 90 Zuege. Falls ohne Aufgabefunktion
@echo gespielt wurde, sind mindestens 100 Zuege empfohlen. Fuer eine komplette Suche 250 Zuege eingeben.
@echo off
set /p moves=
set /A movelimit=moves
if %movelimit% LEQ 80 set /A movelimit=80
if %movelimit% GEQ 250 set /A movelimit=250

REM *************************************
REM *** Start of code, do not change! ***
REM *************************************
@echo Lese pgn-file: %gamebase%
set resultbase_withsac=games_with_sacrifices.pgn
set /A resultnumber=0
del %resultbase_withsac% 2>nul

cd ./bin

fsutil file createnew results.pgn 0 >NUL
fsutil file createnew whitewins.pgn 0 >NUL
fsutil file createnew blackwins.pgn 0 >NUL
fsutil file createnew blacksacs.pgn 0 >NUL
@echo ***************************************************************
@echo *** Filtern aller Gewinnpartien
@echo ***************************************************************

REM *** filtering the white wins and black wins and put them in different files ***
pgn-extract --quiet -bl20 -bu%movelimit% -Tr1-0 ../%gamebase% --output whitewins.pgn > NUL
pgn-extract --quiet -bl20 -bu%movelimit% -Tr0-1 ../%gamebase% --output blackwins.pgn > NUL

@echo *** Suche nach Opfern in den weissen Gewinnpartien
@echo ***************************************************************
if %whatwork% EQU 1 pgn-extract --quiet -ysacwhite_turbo whitewins.pgn --output results.pgn >NUL
if %whatwork% EQU 2 pgn-extract --quiet -ybigsacwhite whitewins.pgn --output results.pgn >NUL
if %whatwork% EQU 3 pgn-extract --quiet -ybigsac_nopawns_white whitewins.pgn --output results.pgn >NUL

@echo *** Suche nach Opfern in den schwarzen Gewinnpartien
@echo ***************************************************************
if %whatwork% EQU 1 pgn-extract --quiet -ysacblack_turbo blackwins.pgn --output blacksacs.pgn >NUL
if %whatwork% EQU 2 pgn-extract --quiet -ybigsacblack blackwins.pgn --output blacksacs.pgn >NUL
if %whatwork% EQU 3 pgn-extract --quiet -ybigsac_nopawns_black blackwins.pgn --output blacksacs.pgn >NUL

REM *** Merge all found games in one single file ***
pgn-extract --quiet -aresults.pgn blacksacs.pgn >NUL

set /A gesamtzahl=0
REM *** Count the number of games in the gamebase...
for /f "tokens=2,* delims=PGN: " %%G in ('find /C "[White " results.pgn') do set /A gesamtanzahl=%%H

pgn-extract --quiet -a../%resultbase_withsac% results.pgn >NUL

REM *** delete all working files ***
del results.pgn 2>nul
del whitewins.pgn 2>nul
del blackwins.pgn 2>nul
del blacksacs.pgn 2>nul
del workongame.pgn 2>nul
del found.pgn 2>nul
del onegame.pgn 2>nul
del workbase.pgn 2>nul
del sacfound.pgn 2>nul

cd ../

@echo ****************
@echo ***  Fertig  ***
@echo ****************
@echo ************************************************************************
@echo Zahl der gefundenen Opferpartien: %gesamtanzahl%
@echo (Partien in der Ausgabedatei sind nach Weiss- und Schwarzsiegen sortiert)
@echo Alle Opferpartien in dieser Datei gespeichert:
@echo %resultbase_withsac%
@echo ************************************************************************

CALL ./bin/playwav %windir%/media/alarm02.wav
pause
